<?php

	/*
	 * Addon tvsfeuser
	 * @author wandel[at]thavis[dot]com Michael Wandel
	 * @author <a href="http://www.thavis.com">www.thavis.com</a>
	 * @package redaxo4
	 * @version $Id: index.inc.php,v 1.0 2010/07/16 12:00:00 kills Exp $
	 */

	$rexversion		= $REX['VERSION'] . $REX['SUBVERSION'];
	$user_table		= $table_pre . "_user";
	$thispage		= "tvsfeuser";
	$thissubpage	= "access";
	$myIniFile		= $REX['INCLUDE_PATH'] . "/addons/" . $thispage . "/" . $thispage . ".ini";
	$baseURL		= 'index.php?page='.$thispage.'&amp;subpage='.$thissubpage;

	$rights			= rex_post('rights', 'array', '');
	$redir_link		= rex_post('redir_link', 'string', '');
	$redir_link_name= rex_post('redir_link_name', 'string', '');
	$mode			= rex_post('mode', 'string', '');
	
	$submit_rights = rex_post('submit_rights', 'string', '');
	
	if (!function_exists('articleMapStart')):
		function articleMapStart($lastlev=0, $ebene=0)
		{
			if (!is_object($lastlev) and !isset($lastlev) || $lastlev == 0):
				foreach (OOCategory::getRootCategories() as $aktlev) {
					articleMapPrint($aktlev,$ebene);
				}
			elseif (is_object($lastlev)):
				foreach ($lastlev->getChildren() as $aktlev):
					articleMapPrint($aktlev,$ebene);
				endforeach;
			else:
				$aktlev = OOCategory::getCategoryById($lastlev);
				articleMapPrint($aktlev,$ebene);
			endif;
			$ebene -= 1;
		}
	endif;

	if (!function_exists('articleMapPrint')) {
		function articleMapPrint($aktlev, $ebene)
		{
			global $rights;
			if ($aktlev->isOnline())
				$class = "class=\"rex-online\"";
			else
				$class = "class=\"rex-offline\"";
			$aktlevSize = sizeof($aktlev->getChildren());
		
			$rights_array= explode(",", $rights);
			$articles = $aktlev->getArticles();
			if(is_array($articles) && count($articles) > 0) {
				foreach ($articles as $art) {
					if (in_array($art->getId(), $rights_array))
						$selected = "selected = \"selected\"";
					else
						$selected = "";
					if ($art->isStartArticle())
						$filler = str_repeat('&nbsp;&nbsp;&nbsp;',$ebene);
					else
						$filler = str_repeat('&nbsp;&nbsp;&nbsp;',$ebene+1);
					if (isset ($art) and is_object($art)) {
						echo "<option value=\"" . $art->getId() . "\" " . $selected . $class . ">" . $filler . $art->getName() . "</option>";
					}
				}
			}
			if ($aktlevSize != "0") {
				$ebene += 1;
				articleMapStart($aktlev, $ebene);
			}
		}
	}

	// Erstmal schauen ob gespeichert werden soll...
	if ($func == "write" && !isset($cancel))
	{
		
		$new_rights = implode(',' , $rights);
		$new_keys = "accessRestrictions=" . $new_rights . chr(10);
		$new_keys .= "Redir_Link=" . $redir_link . chr(10);
		$new_keys .= "Redir_Link_Name=" . $redir_link_name . chr(10);

		$fh = fopen($myIniFile, 'w') or die("Can't open " . $thispage . ".ini.");
		fwrite($fh, $new_keys);
		fclose($fh);
		echo rex_info("Einstellungen gespeichert!");
	}

	// dann Neueinlesen der ini...
	if (file_exists($myIniFile)) {
		$stringData = file_get_contents($myIniFile);
		$settings = parse_ini_file($myIniFile);
		
		$rights				= $settings['accessRestrictions'];
		$redir_link			= $settings['Redir_Link'];
		$redir_link_name	= $settings['Redir_Link_Name'];
	}

	// ..und wenn jetzt noch die Userrechte ALLE gesetzt werden sollen...
	if ($submit_rights != "") {
		$sql = new rex_sql();
		$sql->setQuery("UPDATE " . $user_table . " SET rights = '" . $rights . "'");
		echo rex_info("Benutzerrechte wurden ALLEN Benutzern zugewiesen!");
	}

?>

	<div class="rex-addon-output">
		<h2 class="rex-hl2">Zugriffsrechte verwalten</h2>
		<div id="rex-addon-editmode" class="rex-form">
		<form action="<?php echo $baseURL; ?>" method="post">
			<fieldset class="rex-form-col-1">

				<input type="hidden" name="page" value="<?php echo $thispage; ?>" />
				<input type="hidden" name="subpage" value="<?php echo $thissubpage; ?>" />
				<input type="hidden" name="func" value="write" />
				<input type="hidden" name="mode" value="<?php echo htmlspecialchars($func); ?>" />

				<div class="rex-form-wrapper">

				<?php
					if ($redir_link == "") {
				?>
					<div class="rex-form-row">
						<p class="rex-form-col-a rex-form-text rex-offline">
							<label for="no_redir_link">&nbsp;</label>
							<b>Fehler: Es wurde keine Login-Seite angegeben!</b>
						</p>
					</div>
				<?php
					}
				?>

				<div class="rex-form-row">
					<p class="rex-form-col-a rex-form-select">
						<label for="rights">Artikelberechtigungen:<br /><br />(Mehrfachauswahl<br />mit &lt;STRG&gt;)</label>
						<select name="rights[]" size="20" multiple="multiple" class="rex-form-select">
						<?php
							articleMapStart();
							$rootArticles = OOArticle::getRootArticles(false, false);
							foreach($rootArticles as $rootArticle) {
								if ($rootArticle->isOnline())
									$class = "class=\"rex-online\"";
								else
									$class = "class=\"rex-offline\"";
									
								$rights_array= explode(",", $rights);
								if (in_array($rootArticle->getId(), $rights_array))
									$selected = "selected = \"selected\"";
								else
									$selected = "";
								echo "<option value=\"" . $rootArticle->getId() . "\" " . $selected . $class . ">" . $rootArticle->getName() . "</option>";
							}
						?>
						</select>
					</p>
				</div>
				
				<div class="rex-form-row">
					 <p class="rex-form-col-a rex-form-text">
						<label for="redir_link">Login-Seite:</label>
						<input type="hidden" name="redir_link" id="LINK_1" value="<?php echo $redir_link; ?>" /> <input type="text" size="10" name="redir_link_name" value="<?php echo $redir_link_name; ?>" id="LINK_1_NAME" readonly="readonly" /> <a href="#" onclick="openLinkMap('LINK_1', '&clang=0&category_id=0');return false;" tabindex="24">  <img src="media/file_open.gif" width="16" height="16" alt="Öffne Strukturbaum" title="Öffne Strukturbaum" /> </a>
						<a href="#" onclick="deleteREXLink(1);return false;" tabindex="25">  <img src="media/file_del.gif" width="16" height="16" title="Auswahl entfernen" alt="Auswahl entfernen" /> </a>
					</p>
				</div>

				<div class="rex-form-row">&nbsp;</div>

				<div class="rex-form-row">
					<p class="rex-form-col-a rex-form-submit rex-form-submit-2">
						<input type="submit" name="submit" class="rex-form-submit submit" value="Speichern" />
						<input type="submit" name="submit_rights" class="rex-form-submit submit" value="Rechte allen Usern zuweisen" />
					</p>
				</div>

			</div>
			</fieldset>
		</form>
		</div>
		
	</div>
